services:
  # this needs to stay as close to production as possible - this compose file is used when testing the image
  # the dev-related changes need to placed to the override file
  web:
    build:
      context: .
    environment:
      APP_DB_DSN: "mysql://user:pass@mysql:3306/db?serverVersion=8.0"
      APP_DB_DSN_READMODELS: "mysql://user:pass@mysql:3306/db_readmodels?serverVersion=8.0"
      APP_ENV: "prod"
      APP_MONGO_CONN_URI: "mongodb://user:password@mongo-0:27017,mongo-1/admin" #?replicaSet=myReplSet"
      APP_MONGO_DB: "db"
      APP_OAUTH_ENCRYPTION_DEFUSE_KEY: "def00000259ea1b3de5d1933f14ed10bef1d73f4ef6ab8318d33f3d1f0d519232401a1360c182190181e75e13e937cc8abc0c5638c0e467984eb94964e2d9cc2e4579172"
      APP_WEBMAIL_URL: "https://localhost/"
      APP_MAILER_DSN: "sendmail://default?command=/usr/bin/msmtp%20-t%20-i%20--tls-certcheck=off"
      APP_QUOTA_REPORTING_SENDER: "report@example.com"
      MAIL_RELAYHOST: "postfix-main"
      APP_2FA_GOOGLE_SERVER_NAME: "Craynic.net"
      APP_2FA_GOOGLE_ISSUER: "Craynic, s.r.o."
    ports:
      - "8000:80"
      - "8443:443"
    volumes:
      - "./test-data/oauth/:/var/www/home/oauth"
      - "./test-data/ssl-certs/:/etc/ssl/apache2"
    deploy:
      resources:
        limits:
          memory: 500M
    extra_hosts:
      - "host.docker.internal:host-gateway"

  mysql:
    image: "mysql:9"
    command: "--log-bin-trust-function-creators"
    environment:
      LANG: C.UTF-8
      MYSQL_USER: "user"
      MYSQL_PASSWORD: "pass"
      MYSQL_DATABASE: "db"
      MYSQL_ROOT_PASSWORD: "toor"
    ports:
      - "3306:3306"
    cap_add:
      - SYS_NICE
    deploy:
      resources:
        limits:
          memory: 500M

  mongo-0:
    image: registry.gitlab.com/craynic.com/craynic.net/mvh/mongodb
    hostname: "mongo-0"
    environment:
      MONGO_INITDB_ROOT_USERNAME: "root"
      MONGO_INITDB_ROOT_PASSWORD: "toor"
      MONGO_REPLICASET_KEY_CONTENTS: "abcdef"
      MONGO_REPLICASET_NAME: "myReplSet"
    deploy:
      resources:
        limits:
          memory: 500M

  mongo-1:
    image: registry.gitlab.com/craynic.com/craynic.net/mvh/mongodb
    hostname: "mongo-1"
    environment:
      MONGO_INITDB_ROOT_USERNAME: "root"
      MONGO_INITDB_ROOT_PASSWORD: "toor"
      MONGO_REPLICASET_KEY_CONTENTS: "abcdef"
      MONGO_REPLICASET_NAME: "myReplSet"
    deploy:
      resources:
        limits:
          memory: 500M

  postfix-main:
    image: registry.gitlab.com/craynic.com/craynic.net/mail/postfix-main
    environment:
      POSTFIX_HOSTNAME: "postfix-main"
      POSTFIX_MYSQL_HOST: "mysql"
      POSTFIX_MYSQL_USER: "user"
      POSTFIX_MYSQL_PASS: "pass"
      POSTFIX_MYSQL_DB: "db_readmodels"
      POSTFIX_DEFAULT_TRANSPORT: "[postfix-outgoing]:25"
      POSTFIX_DOVECOT_LMTP_TRANSPORT: "[host.docker.internal]:24"
    volumes:
      - "./test-data/ssl-certs/:/opt/postfix/ssl"
    deploy:
      resources:
        limits:
          memory: 500M
    extra_hosts:
      - "host.docker.internal:host-gateway"
